SystemOrganization addCategory: #'Tweak-Demo'!

CPlayer subclass: #CColorListDemo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Demo'!

CColorListDemo defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="colors" toSet="colors:" changeEvent="colorsChanged">colors</field>
	<field toGet="cursor" toSet="cursor:" changeEvent="cursorChanged">cursor</field>
</fields>'!

!CColorListDemo methodsFor: 'accessing' stamp: 'ar 6/23/2005 14:02'!
colors
	"Answer the colors of the receiver"
	<bewareOf: #colorsChanged>
	^self propertyValueAt: #colors! !

!CColorListDemo methodsFor: 'accessing' stamp: 'ar 6/23/2005 14:02'!
colors: aValue
	"Modify the receiver's colors"
	^self propertyValueAt: #colors put: aValue with: #colorsChanged! !

!CColorListDemo methodsFor: 'accessing' stamp: 'ar 6/23/2005 14:03'!
cursor
	"Answer the cursor of the receiver"
	<bewareOf: #cursorChanged>
	^self propertyValueAt: #cursor! !

!CColorListDemo methodsFor: 'accessing' stamp: 'ar 6/23/2005 14:03'!
cursor: aValue
	"Modify the receiver's cursor"
	^self propertyValueAt: #cursor put: aValue with: #cursorChanged! !

!CColorListDemo methodsFor: 'initialize' stamp: 'ar 6/23/2005 14:27'!
defaultCostume
	| cc |
	cc := CPlayerIconList new.
	cc label: 'Colors:'.
	cc list items: colors.
	^cc! !

!CColorListDemo methodsFor: 'initialize' stamp: 'ar 6/23/2005 15:25'!
initialize
	| aPlayer |
	super initialize.
	self define: #colors as: CCollection new.
	#(red green yellow cyan blue orange magenta lightGreen black white) do:[:cc|
		aPlayer := CPlayer new.
		aPlayer name: cc.
		aPlayer color: (Color perform: cc).
		aPlayer extent: 32@32.
		colors add: aPlayer.
	].
	colors wrapCursor: true.
	cursor := 0.
	value := Color transparent.! !

!CColorListDemo methodsFor: 'events' stamp: 'ar 6/23/2005 14:04'!
onColorCursorChanged
	<on: cursorChanged in: colors>
	cursor := colors cursor.! !

!CColorListDemo methodsFor: 'events' stamp: 'ar 6/23/2005 15:15'!
onCursorChanged
	"Compute my new value based on the new cursor"
	| max index fraction start end |
	<on: cursorChanged>
	max := colors size.
	max = 0 
		ifTrue:[cursor := 0]
		ifFalse:[cursor := cursor - 1 \\ max + 1].
	index := cursor truncated.

	"pause these scripts while changing the cursor"
	self pauseScript: #onColorCursorChanged.
	colors cursor: index.
	self resumeScript: #onColorCursorChanged.

	"And compute new value"
	cursor = 0 ifTrue:[^self value := Color transparent].

	start := colors at: colors cursor.
	end := colors at: (colors cursor \\ max + 1).
	fraction := cursor \\ 1.0.
	value := end color alphaMixed: fraction with: start color.
! !

!CColorListDemo methodsFor: 'initialize' stamp: 'ar 6/23/2005 15:25'!
setupCostume
	super setupCostume.
	self borderStyle: #simple.
	self borderColor: CWidgetLibrary default frameColor.
	self borderWidth: 1.
	self color: self borderColor.
	self roundCorners := true.
	self layoutInset: 4.
	self extent := 220@110.
	self asPrimCostume localCache: CFormCache new.! !

!CColorListDemo methodsFor: 'initialize' stamp: 'ar 6/23/2005 14:10'!
valueType
	^Color! !

CPlayer subclass: #CFlasher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Demo'!

!CFlasher commentStamp: '<historical>' prior: 0!
CFlasher is a trivial little demo to make some flashing object.!

CFlasher defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CFlasher methodsFor: 'initialize' stamp: 'ar 5/11/2005 11:48'!
defaultCostume
	^CEllipsePlayer! !

!CFlasher methodsFor: 'events' stamp: 'ar 5/26/2005 00:20'!
onTick
	<ticking: 2>
	color = Color white
		ifTrue:[color := Color red]
		ifFalse:[color := Color white].! !
